"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = makeConfig;

var _fs = _interopRequireDefault(require("fs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// Default config
var defaultConfig = {
  host: {
    env: 'HOST',
    "default": '0.0.0.0'
  },
  port: {
    env: 'PORT',
    "default": 80
  },
  serving: 'public',
  root: 'index.html'
  /**
   * Makes config object according to file name. If filename does not exist,
   * return default config. Else return config from filename, with config
   * values not set set to default config values
   *
   * @param {string} filename name of config file
   *
   * @return {object} servekaro config
   */

};

function makeConfig(filename) {
  try {
    var customConfig = JSON.parse(_fs["default"].readFileSync(filename));
    return _objectSpread({}, defaultConfig, customConfig);
  } catch (e) {
    return defaultConfig;
  }
}
