"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = servekaro;
exports.resolve = resolve;
exports.servebanado = servebanado;

var _http = _interopRequireDefault(require("http"));

var _requestHandler = _interopRequireDefault(require("./request-handler"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * Serves a servekaro server from config
 *
 * @param {object} config servekaro config
 * @param {function} callback callback called after listen function
 *
 * @return {Server} http server
 */
function servekaro(config, callback) {
  return servebanado(config).listen(resolve(config.port), resolve(config.host), callback);
}
/**
 * Resolves environment config variables
 *
 * @param {string|object} configVar config variable
 *
 * @return {any} resulting value
 */


function resolve(configVar) {
  if (_typeof(configVar) === 'object') {
    return process.env[configVar.env] || configVar["default"];
  } else {
    return configVar;
  }
}
/**
 * Creates an http server from the given config
 *
 * @param {object} config servekaro config
 *
 * @return {Server} http server
 */


function servebanado(config) {
  return _http["default"].createServer((0, _requestHandler["default"])(config));
}
